<?php

namespace Drupal\simple_menu_permissions\Access;

use Drupal\system\MenuAccessControlHandler as CoreMenuAccessControlHandler;
use Drupal\Core\Access\AccessResult;
use Drupal\Core\Entity\EntityInterface;
use Drupal\Core\Session\AccountInterface;

/**
 * Extends the access control handler for the menu entity type.
 *
 * @see \Drupal\system\Entity\Menu
 */
class MenuAccessControlHandler extends CoreMenuAccessControlHandler {

  /**
   * {@inheritdoc}
   */
  protected function checkAccess(EntityInterface $entity, $operation, AccountInterface $account) {
    return match ($operation) {
      'update' => AccessResult::allowedIf($account->hasPermission('edit ' . $entity->id() . ' menu')),
      'delete' => AccessResult::allowedIf($account->hasPermission('delete ' . $entity->id() . ' menu')),
      default => parent::checkAccess($entity, $operation, $account),
    };
  }

}
