<?php

namespace Drupal\simple_menu_permissions\Access;

use Drupal\menu_link_content\MenuLinkContentAccessControlHandler as CoreMenuLinkContentAccessControlHandler;
use Drupal\Core\Access\AccessResult;
use Drupal\Core\Entity\EntityInterface;
use Drupal\Core\Session\AccountInterface;

/**
 * Extends the access control handler for the menu link content entity type.
 */
class MenuLinkContentAccessControlHandler extends CoreMenuLinkContentAccessControlHandler {

  /**
   * {@inheritdoc}
   */
  protected function checkAccess(EntityInterface $entity, $operation, AccountInterface $account) {
    return match ($operation) {
      'update' => AccessResult::allowedIf($account->hasPermission('edit links in ' . $entity->getMenuName() . ' menu')),
      'delete' => AccessResult::allowedIf($account->hasPermission('delete links in ' . $entity->getMenuName() . ' menu')),
      default => parent::checkAccess($entity, $operation, $account),
    };
  }

}
