<?php

declare(strict_types=1);

namespace Drupal\simple_menu_permissions\Controller;

use Drupal\Core\Controller\ControllerBase;
use Drupal\Core\Session\AccountProxyInterface;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * Controller for the simple menu permissions module.
 */
final class SimpleMenuPermissionsController extends ControllerBase {

  /**
   * Returns a list of selectable menu's for the current user.
   */
  public function getSelectableMenus(): array {
    $menus = $this->entityTypeManager()->getStorage('menu')->loadMultiple();

    $menus = array_filter($menus, function ($menu) {
      return $this->currentUser()->hasPermission('add new links to ' . $menu->id() . ' menu');
    });

    return array_map(function ($menu) {
      return $menu->label();
    }, $menus);
  }

}
