<?php

namespace Drupal\simple_menu_permissions\Routing;

use Drupal\Core\Routing\RouteSubscriberBase;
use Symfony\Component\Routing\RouteCollection;

/**
 * Subscriber for altering menu and menu item routes.
 */
class RouteSubscriber extends RouteSubscriberBase {

  /**
   * {@inheritdoc}
   */
  protected function alterRoutes(RouteCollection $collection): void {
    if ($route = $collection->get('entity.menu.add_form')) {
      $route->setRequirement('_permission', 'create new menu');
    }

    if ($route = $collection->get('entity.menu.edit_form')) {
      $route->setRequirement('_custom_access', '\Drupal\simple_menu_permissions\Access\MenuRoutesAccessChecker::checkAccess');
    }

    if ($route = $collection->get('entity.menu.delete_form')) {
      $route->setRequirement('_custom_access', '\Drupal\simple_menu_permissions\Access\MenuRoutesAccessChecker::checkAccess');
    }

    if ($route = $collection->get('entity.menu.add_link_form')) {
      $route->setRequirement('_custom_access', '\Drupal\simple_menu_permissions\Access\MenuRoutesAccessChecker::checkAccess');
    }
  }

}
